#include "DirectionalBillboardParticle.h"
#include <math.h>
#include <iostream>

DirectionalBillboardParticle::DirectionalBillboardParticle(float lifetime, GLfloat x, GLfloat y, GLfloat z, 
                      GLfloat r, GLfloat g, GLfloat b, GLfloat a,
                      GLuint textureId, float size,
                      GLfloat dirX, GLfloat dirY, GLfloat dirZ, float velocity) : BillboardParticle(lifetime, x, y, z, r, g, b, a, textureId, size) {
    float dist = sqrt(dirX * dirX + dirY * dirY + dirZ * dirZ);
    direction[0] = dirX / dist;
    direction[1] = dirY / dist;
    direction[2] = dirZ / dist;
    this->velocity = velocity;               
}

void DirectionalBillboardParticle::idle(float deltaTime) {
    BillboardParticle::idle(deltaTime);
    position[0] = position[0] + velocity * deltaTime * direction[0];
    position[1] = position[1] + velocity * deltaTime * direction[1];
    position[2] = position[2] + velocity * deltaTime * direction[2];
}

void DirectionalBillboardParticle::setDirectionX(GLfloat x) {
    direction[0] = x;
    float dist = sqrt(direction[0] * direction[0] + direction[1] * direction[1] + direction[2] * direction[2]);
    direction[0] = direction[0] / dist;
    direction[1] = direction[1] / dist;
    direction[2] = direction[2] / dist;
}

void DirectionalBillboardParticle::setDirectionY(GLfloat y) {
    direction[1] = y;
    float dist = sqrt(direction[0] * direction[0] + direction[1] * direction[1] + direction[2] * direction[2]);
    direction[0] = direction[0] / dist;
    direction[1] = direction[1] / dist;
    direction[2] = direction[2] / dist;
}

void DirectionalBillboardParticle::setDirectionZ(GLfloat z) {
    direction[2] = z;
    float dist = sqrt(direction[0] * direction[0] + direction[1] * direction[1] + direction[2] * direction[2]);
    direction[0] = direction[0] / dist;
    direction[1] = direction[1] / dist;
    direction[2] = direction[2] / dist;
}
