#ifndef DIRECTIONAL_BILLBOARD_PARTICLE_H
#define DIRECTIONAL_BILLBOARD_PARTICLE_H

#include "BillboardParticle.h"

class DirectionalBillboardParticle : public BillboardParticle {
  private:
    GLfloat direction[3];
    float velocity;
        
  public:
    DirectionalBillboardParticle(float lifetime, GLfloat x, GLfloat y, GLfloat z, 
                      GLfloat r, GLfloat g, GLfloat b, GLfloat a,
                      GLuint textureId, float size, 
                      GLfloat dirX, GLfloat dirY, GLfloat dirZ, float velocity);
    
    virtual void idle(float deltaTime);
    
    GLfloat getDirectionX() { return direction[0]; }
    GLfloat getDirectionY() { return direction[1]; }
    GLfloat getDirectionZ() { return direction[2]; }        
    
    void setDirectionX(GLfloat x);
    void setDirectionY(GLfloat y);
    void setDirectionZ(GLfloat z);   

    float getVelocity() { return velocity; }
    void setVelocity(float v) { velocity = v; }
    
};

#endif
