#include "Gold.h"
#include "Room.h"

Gold::Gold(Detector* detector, Room* room) : Object(detector, "Models/coin.obj", "Textures/coin.tga") {
    model->setScale(0.5);
    rotate = 0;
    if (rand() % 2 == 0) {
        flip();
    }
    this->room = room;
    this->detector = detector;
}

Gold::~Gold() {
    detector->removeObject(this);
    room->removeGold(this);
}

void Gold::flip() {
    rotate = 180;
}

void Gold::draw() {
    glPushMatrix();
    glColor3f(1,1,1);
    if (rotate == 180) {
        glTranslatef(positionX,0.1,positionZ);
        glRotatef(rotate,0,0,1);
        glTranslatef(-positionX,0,-positionZ);
    }
    Object::draw();
    glPopMatrix();
}
