#include "LineParticle.h"

LineParticle::LineParticle(float lifetime, GLfloat r, GLfloat g, GLfloat b, GLfloat a) {
    this->lifetime = lifetime;
    color[0] = r;
    color[1] = g;
    color[2] = b;
    color[3] = a;
}

LineParticle::LineParticle(float lifetime, GLfloat x, GLfloat y, GLfloat z, GLfloat r, GLfloat g, GLfloat b, GLfloat a) : Particle(x,y,z) {
    this->lifetime = lifetime;
    color[0] = r;
    color[1] = g;
    color[2] = b;
    color[3] = a;
}

void LineParticle::draw() {
    glColor4fv(color);
    glPushMatrix();
    glTranslatef(position[0], position[1], position[2]);
    glBegin(GL_LINES);
        glVertex3f(0,0,0);
        glVertex3f(0,0.05,0);
    glEnd();
    glPopMatrix();
}

void LineParticle::idle(float deltaTime) {
    lifetime -= deltaTime;
    if (lifetime <= 0) {
        alive = false;    
    }
}
