#ifndef _OBJECT_H_
#define _OBJECT_H_

#include <GL/glut.h>
#include "Utils.h"
#include "Model.h"
#include <string>
#include "Detector.h"

class Object {
    
protected:

    float positionX;
    float positionY;
    float positionZ;
    float orientation;
    
    Detector* detector;

    Model* model;
    GLuint tex;
    
    bool bshowText;
    char textToShow[13];
    float textTimeLeft;
    GLfloat textColor[3];
    
public:

    Object();
    ~Object();
    Object(Detector* detector, int wall_type);
    Object(Detector* detector, std::string modelFileName, std::string textureFileName);
    virtual void draw();
    virtual void idle(float deltaTime);
    void setPosition(float positionX, float positionY, float positionZ, float orientation);
    float getPositionX();
    float getPositionY();
    float getPositionZ();
    float getOrientation();
    virtual void moveForward(float deltaTime);
    virtual void moveBackward(float deltaTime);
    void rotateCW(float deltaTime);
    void rotateCCW(float deltaTime);
    virtual void getBoundingVolume(float *minX,float *maxX,
                           float *minY,float *maxY,
                           float *minZ,float *maxZ);
                           
    void showText(char* text, float timePeriod);                           

};

#endif //_OBJECT_H_
