#include "ParticleSystem.h"
#include "Particle.h"

ParticleSystem::ParticleSystem(int numParticles) {
    this->numParticles = numParticles;
    active = true;
    particles = new Particle*[numParticles];
}

ParticleSystem::~ParticleSystem() {
    delete[] particles;
}

void ParticleSystem::draw() {
    if (active) {
        glDisable(GL_LIGHTING);
        glEnable(GL_BLEND);
        glDepthMask(GL_FALSE);
        for (int i = 0; i < numParticles; i++) {
            if (particles[i]->isAlive()) {
                particles[i]->draw();   
            } 
        }
        glDepthMask(GL_TRUE);
        glEnable(GL_LIGHTING);
        glDisable(GL_BLEND);        
    }
}
