#ifndef RAIN_PARTICLE_SYSTEM_H
#define RAIN_PARTICLE_SYSTEM_H

#include "ParticleSystem.h"

/*
 * Particle system that simulates falling rain
 */
class RainParticleSystem : public ParticleSystem{
  private:
    GLfloat r; //red color component
    GLfloat g; //green color component
    GLfloat b; //blue color component
    GLfloat top; //top bounding plane
    GLfloat bottom; //bottom bounding plane
    GLfloat left; //left bounding plane
    GLfloat right; //right bounding plane
    GLfloat front; //front bounding plane
    GLfloat back; //back bounding plane
    float lifetimeLower; //lower bound on lifetime
    float lifetimeUpper; //upper bound on lifetime
    float fallRate;
  public:   
    RainParticleSystem(int numParticles, float dropSize, float lifetimeLower, float lifetimeUpper, float fallRate,
                       GLfloat r, GLfloat g, GLfloat b,
                       GLfloat top, GLfloat bottom, GLfloat left, GLfloat right, GLfloat front, GLfloat back);
    ~RainParticleSystem();
    
    virtual void idle(float deltaTime);
};

#endif
