#ifndef _ROOM_H_
#define _ROOM_H_

#include <list>
#include "Detector.h"
#include "Wizard.h"
#include "Wall.h"
#include "Gold.h"
class Level;

class Room {
    
private:

    std::list<Wall*> walls;
    std::list<Enemy*> enemies;
    std::list<Gold*> coins;
    Detector* detector;
    Wizard* wizard;
    
    Level* level;
    
    float xmin, xmax, zmin, zmax;
    
public:

    /*          2
     *      ----------
     *      |        |
     *      |        |
     *    4 |        | 8
     *      |        |
     *      ----------
     *          1
     */

    Room(Detector* detector, Wizard* wizard,
         float xmin, float xmax, float zmin, float zmax,
         int doorLocation, int wallLocation, bool bossRoom, Level* level, int wall_type);
    ~Room();
    void draw();
    void drawForPick();
    void idle(float deltaTime);
    bool inRoom(float x, float y, float z);
    void removeGold(Gold* object);
    void removeEnemy(Enemy* object);

};

#endif //_ROOM_H_
