#ifndef UTILS_H
#define UTILS_H

#include <GL/glut.h>
#include <map>
#include <string>

class Utils { 
    private:
    static std::map<std::string, GLuint> textures;
    public:
    static void loadTexture(std::string name, GLuint* dest, GLenum type, bool clamp);
    static float random(float lowerBound, float upperBound);
    static int randomInt(int lowerBound, int upperBound);
    //linear interpolation
    static float interpVal(float desired, float current, float deltaTime, float timeLeft);
    static void renderString(int x, int y, char* string, void* font);
    static void renderString(float x, float y, float z, char* string, void* font);
};

#endif
